//------------------------------------------------------------------------------
// SystmD
// www.systmd.com
// Modifi le 08/10/2005
//------------------------------------------------------------------------------

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Jpeg,
  ExtDlgs, Buttons, ExtCtrls, OleCtrls, SHDocVw;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    BtnAdapter: TSpeedButton;
    BtnTailleReelle: TSpeedButton;
    SpeedButton3: TSpeedButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure SpeedButton3Click(Sender: TObject);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure BtnTailleReelleClick(Sender: TObject);
    procedure BtnAdapterClick(Sender: TObject);
    procedure WebBrowser1DownloadBegin(Sender: TObject);
    procedure FormResize(Sender: TObject);
    

  private
    { Dclarations prives }
     procedure DMSZoomAuto;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  // Variables utilises pour DMSZoomAuto
  ImageWidth, ImageHeight: Integer;
  ZW,ZH,Zoom: extended;
  Image:string;

implementation

{$R *.DFM}

procedure TForm1.DMSZoomAuto;// zoom image automatique
begin
if Image<>'' then // si une image est charge
   begin
   If WebBrowser1.OleObject.Document.Images.Length = 1 then // si une image seulement
      begin
      ImageWidth := WebBrowser1.OleObject.Document.Images.Item(0).Width;
      ImageHeight := WebBrowser1.OleObject.Document.Images.Item(0).Height;
      ZW:=Trunc((WebBrowser1.Width*100)div(ImageWidth))-5;
      ZH:=Trunc((WebBrowser1.Height*100)div(ImageHeight))-5;
      if ZW<ZH then Zoom:=(ZW / 100) else Zoom:=(ZH / 100);
      WebBrowser1.OleObject.Document.Body.Style.Zoom := Zoom;
      BtnTailleReelle.visible:=true;
      BtnAdapter.visible:=false;
      end;
   end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
//Ouverture Image
if OpenPictureDialog1.Execute then
  begin
  Image:='file://'+OpenPictureDialog1.FileName;
  try WebBrowser1.Navigate(Image,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  except
  end;
 end;

end;

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
DMSZoomAuto;
end;

procedure TForm1.BtnTailleReelleClick(Sender: TObject);
begin
// Taille relle
WebBrowser1.OleObject.Document.Body.Style.Zoom := 1;
BtnTailleReelle.visible:=false;
BtnAdapter.visible:=true;
end;

procedure TForm1.BtnAdapterClick(Sender: TObject);
begin
DMSZoomAuto;
end;

procedure TForm1.WebBrowser1DownloadBegin(Sender: TObject);
begin
BtnTailleReelle.visible:=false;
BtnAdapter.visible:=false;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
DMSZoomAuto;
end;

end.
